JACKFREQD(1)

NAME
jackfreqd - control CPU speed according to DSP load

SYNOPSIS
jackfreqd [options]

DESCRIPTION
jackfreqd is a variant of powernowd tailored for pro-audio work. This client controls CPU speed and voltage using the sysfs interface to the CPUFreq driver in v2.6 Linux kernels. It does not depend on APM or ACPI, and it doesn't try to do anything other than control the CPU via the userspace governor and sysfs. The CPU-frequency is scaled depending on DSP and (optionally) system-load. As the name implies jackfreqd takes the DSP load from the JACK Audio Connection Kit sound-daemon. On multi-threaded system the system-load may still be too low for a CPU governor to react while DSP-load is already at the limit. In order to gain access to modify CPU-speed and do so quickly, jackfreqd needs to be run as root. It can safely be launched during system startup: jackfreqd can discover and (re-)connect to a JACK instance that is started by any user on the system later on, or it can be made to stick to a instance for a given user-id which runs the JACK-daemon. jackfreqd changes frequency by a sawtooth function: The system immediately jumps to the highest frequency whenever max(DSP-load, CPU-load) exceeds a given threshold (upper limit -u, -U) . As soon as the load drops below the lower limit (-l, -L) the CPU speed is decreased by 'one step'.

OPTIONS

-h  Prints a help message.

-d  Detach from terminal and run in background

-v  Increase output verbosity, can be used more than once.

-q  Quiet mode, only emergency output.

-P  Make frequency scaling decision based on both DSP and CPU load: use higher value of both.

-n  Include nice'd processes in calculations (only with -P).

-c  Specify number of threads per power-managed core.

-s  Frequency step in kHz (default = 100000)

-p  Polling frequency in msecs (default = 1000)

-u  DSP usage upper limit percentage [0 .. 100, default 50]

-l  DSP usage lower limit percentage [0 .. 100, default 10]

-U  CPU usage upper limit percentage [0 .. 100, default 80]

-L  CPU usage lower limit percentage [0 .. 100, default 20]

-w  wait for and re-connect to jackd. Should be combined with -P. Otherwise if no jack process is available CPU will stay in low power-mode independent of CPU activity.

-j  user-name or UID of jackd process (default: autodetect)

-J  group-name or GID of jackd process (default: autodetect)

EXAMPLE
 sudo jackfreqd -P -w -v

AUTHOR

jackfreqd was created by Robin Gareus <robin@gareus.org>. It is based on the powernowd program by John Clemens <clemej@alum.rpi.edu>

COPYRIGHT
Copyright © 2010 Robin Gareus, GNU GPL version 2 or later.
This is free software: you are free to change and redistribute it. There is NO WARRANTY, to the extent permitted by law.